Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SashPanel.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SashPanel.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SashPanel.java	(revision 653)
@@ -0,0 +1,90 @@
+package org.txm.synopticedition.rcp.editors;
+
+import java.util.ArrayList;
+
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.layout.FormAttachment;
+import org.eclipse.swt.layout.FormData;
+import org.eclipse.swt.layout.FormLayout;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.Listener;
+import org.eclipse.swt.widgets.Sash;
+
+public class SashPanel extends Composite {
+
+	//Composite parent;
+	ArrayList<Composite> cells;
+
+	public SashPanel(Composite parent, int style) {
+		super(parent, style);
+		//this.parent = parent;
+		this.setLayout(new FormLayout());
+	}
+
+	public void init(int ncolumns) {
+		if (cells != null) {
+			for(Control c : this.getChildren())
+				c.dispose();
+			cells.clear();
+			cells = new ArrayList<Composite>();
+		}
+
+		cells = new ArrayList<Composite>();
+		Sash sash = null;
+		FormData sashData = null;
+		for (int i = 0 ; i < ncolumns ; i++) {
+			Composite container = new Composite(this, SWT.NONE);
+			container.setLayout(new GridLayout());
+			cells.add(container);
+
+			FormData containerData = new FormData();
+			containerData.width = 100;
+			containerData.top = new FormAttachment(0, 0);
+			containerData.bottom = new FormAttachment(100, 0);
+			container.setLayoutData(containerData);// set new layout data
+
+			if (sash != null) { // attached FormData to previous sash and vice-versa
+				sashData.right = new FormAttachment(container, 0);
+				containerData.left = new FormAttachment(sash, 0);
+			} else if (i == 0) {
+				containerData.left = new FormAttachment(0, 0); // first cell
+			}
+
+			if (i == ncolumns -1 ) {
+				containerData.right = new FormAttachment(100, 0); // last cell
+			} else {
+				sash = new Sash(this, SWT.VERTICAL);
+				containerData.right = new FormAttachment(sash, 0);
+
+				sashData = new FormData();
+				sashData.left = new FormAttachment(container, 0);
+				sashData.top = new FormAttachment(0, 0);
+				sashData.bottom = new FormAttachment(100, 0);
+				sash.setLayoutData(sashData);
+			}
+			sash.addListener(SWT.Selection, new Listener() {
+				@Override
+				public void handleEvent(Event e) {
+					SashPanel.this.layout();
+					//								e.getBounds()
+					//								Rectangle sashRect = sash.getBounds();
+					//								Rectangle shellRect = SashPanel.this.getClientArea();
+					//								int right = shellRect.width - sashRect.width;
+					//								e.x = Math.max(Math.min(e.x, right), 0);
+					//								if (e.x != sashRect.x) {
+					//									sashData.left = new FormAttachment(0, e.x);
+					//									parentContainer.layout();
+					//								}
+				}
+			});
+		}
+
+	}
+
+	public Composite getContainer(int i) {
+		return cells.get(i);
+	}
+}

Index: tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditorInput.java
===================================================================
--- tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditorInput.java	(revision 0)
+++ tmp/org.txm.synopticeditor.rcp/src/org/txm/synopticedition/rcp/editors/SynopticEditorInput.java	(revision 653)
@@ -0,0 +1,112 @@
+package org.txm.synopticedition.rcp.editors;
+
+import org.eclipse.jface.resource.ImageDescriptor;
+import org.eclipse.ui.IEditorInput;
+import org.eclipse.ui.IPersistableElement;
+import org.eclipse.ui.plugin.AbstractUIPlugin;
+import org.txm.objects.Text;
+import org.txm.rcp.Application;
+import org.txm.rcp.IImageKeys;
+import org.txm.rcp.editors.TXMResultEditorInput;
+import org.txm.searchengine.cqp.corpus.Corpus;
+
+import cern.colt.Arrays;
+
+public class SynopticEditorInput extends TXMResultEditorInput implements IEditorInput {
+
+	private Corpus corpus;
+	private Text text;
+	private String[] editions;
+
+	/**
+	 * Instantiates a new SynopticEditorInput
+	 *
+	 * @param corpus, the corpus
+	 * @param text, the text to show
+	 * @param editions, the editions to show
+	 */
+	public SynopticEditorInput(Corpus corpus, String text, String[] editions) {
+		super(corpus);
+		
+		this.corpus = corpus;
+		corpus = corpus.getMainCorpus();
+		this.editions = editions;
+		
+		if (text == null) {
+			this.text = corpus.getFirstText();
+		} else {
+			this.text = corpus.getText(text);
+		}
+		
+		if (editions == null) {
+			String[] defaultEditions = {corpus.getDefaultEdition()};
+			this.editions = defaultEditions;
+		}
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.IEditorInput#getImageDescriptor()
+	 */
+	@Override
+	public ImageDescriptor getImageDescriptor() {
+		return AbstractUIPlugin.imageDescriptorFromPlugin(
+				Application.PLUGIN_ID, IImageKeys.EDITION);
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.IEditorInput#getName()
+	 */
+	@Override
+	public String getName() {
+		return corpus.getName()+ " - "+text+ " - "+Arrays.toString(editions);  //$NON-NLS-1$ //$NON-NLS-2$
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.IEditorInput#getPersistable()
+	 */
+	@Override
+	public IPersistableElement getPersistable() {
+		return null;
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.IEditorInput#getToolTipText()
+	 */
+	@Override
+	public String getToolTipText() {
+		return getName();
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
+	 */
+	@Override
+	public Object getAdapter(Class adapter) {
+		return null;
+	}
+
+	/**
+	 * Gets the corpus.
+	 *
+	 * @return the corpus
+	 */
+	public Corpus getCorpus() {
+		return corpus;
+	}
+
+	public Text getText() {
+		return text;
+	}
+	
+	public String[] getEditions() {
+		return editions;
+	}
+
+	/* (non-Javadoc)
+	 * @see org.eclipse.ui.IEditorInput#exists()
+	 */
+	@Override
+	public boolean exists() {
+		return false;
+	}
+}

Index: tmp/org.txm.links.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.links.rcp/META-INF/MANIFEST.MF	(revision 652)
+++ tmp/org.txm.links.rcp/META-INF/MANIFEST.MF	(revision 653)
@@ -29,9 +29,9 @@
  org.txm.cooccurrence.rcp;bundle-version="1.0.0";visibility:=reexport,
  org.txm.internalview.rcp;bundle-version="1.0.0";visibility:=reexport,
  org.txm.statsengine.r.rcp;bundle-version="1.0.0";visibility:=reexport,
- org.txm.rcp,
+ org.txm.synopticedition.rcp,
  org.txm.index.rcp,
  org.txm.progression.rcp,
  org.txm.lexicaltable.rcp,
  org.txm.libs.batik
-Export-Package: org.txm.rcp.commands.link
+Export-Package: org.txm.synopticedition.rcp.commands.link
Index: tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java	(revision 652)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java	(revision 653)
@@ -24,7 +24,7 @@
 		
 		String cmd = null;
 		// 2D
-		if (result.getBooleanParameterValue(AHCPreferences.DISPLAY_2D)) {
+		if (result.getBooleanParameterValue(AHCPreferences.RENDERING_2D)) {
 			cmd = "plot.HCPC(" + cah.getSymbol() + ", new.plot=FALSE, choice=\"tree\")";
 			
 		// FIXME: for tests without drawing the inertia barplot. Without it, the max available clusters can exceed 16
Index: tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java	(revision 652)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java	(revision 653)
@@ -36,6 +36,7 @@
 import org.txm.cah.core.preferences.AHCPreferences;
 import org.txm.chartsengine.core.results.ChartResult;
 import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMParameters;
 import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.statsengine.r.core.RWorkspace;
@@ -51,24 +52,24 @@
  */
 public class AHC extends ChartResult	{
 
-	/** The metric. */
-	String pMetric = "euclidean"; // euclidean, manhattan //$NON-NLS-1$
+	/**
+	 * The R name prefix.
+	 */
+	protected static String prefixR = "FactoMineRAHC"; //$NON-NLS-1$
 
-	/** The method. */
-	String pMethod = "ward"; // METHODS <- c("average", "single", "complete", "ward", "weighted", "flexible") //$NON-NLS-1$
+	/**
+	 * Counter used in name suffix.
+	 */
+	protected static int ahcCounter = 1;
+	
 
-	/** The N cluster. */
-	Integer pNCluster = 3;
-
-	/** if true classify columns values. */
-	Boolean pColumns = true;
-
 	/** The symbol. */
 	String symbol = null;
 
 	/** The CA symbol target. */
 	String target;
 
+	
 	/**
 	 * The coordinates of the clusters.
 	 */
@@ -107,48 +108,121 @@
 	protected CA ca;
 	protected LexicalTable table;
 
+	
+	
+	
+	
+	
 	/**
-	 * Instantiates a new cAH.
+	 * The metric (euclidean, manhattan).
+	 */
+	@Parameter(key=AHCPreferences.METRIC)
+	protected String metric;
+
+	/**
+	 * The method (METHODS <- c("average", "single", "complete", "ward", "weighted", "flexible")).
+	 */
+	@Parameter(key=AHCPreferences.METHOD)
+	protected String method;
+
+	/**
+	 * The number of clusters.
+	 */
+	@Parameter(key=AHCPreferences.N_CLUSTERS)
+	protected int numberOfClusters;
+
+	/**
+	 * To compute the columns or the rows.
+	 */
+	@Parameter(key=AHCPreferences.COLUMNS_COMPUTING)
+	protected boolean columnsComputing;
+	
+	/**
+	 * To display in 2D or 3D.
+	 */
+	@Parameter(key=AHCPreferences.RENDERING_2D)
+	protected boolean rendering2D;
+	
+	
+	
+	/**
+	 * Instantiates a new AHC.
 	 *
 	 * @param ca the ca
 	 * @param col the col
-	 * @param pMethod the method
-	 * @param pMetric the metric
-	 * @param pNCluster the n cluster
+	 * @param method the method
+	 * @param metric the metric
+	 * @param numberOfClusters the n cluster
 	 * @param display2D the display mode
 	 */
 	public AHC(CA ca)	{
 		super(ca);
 		this.ca = ca;
-		this.table = ca.getLexicalTable();
-		this.target = ca.getSymbol();
 	}
 
+	@Override
+	protected boolean _compute()	{
+
+		
+		Log.info("Computing CAH...");
+		try {
+			this.table = this.ca.getLexicalTable();
+			this.target = this.ca.getSymbol();
+
+			// reset the number of clusters to default
+			if(this.hasParameterChanged(AHCPreferences.COLUMNS_COMPUTING))	{
+				this.numberOfClusters = TXMPreferences.getInt(AHCPreferences.N_CLUSTERS, AHCPreferences.PREFERENCES_NODE);
+			}
+
+			
+			String colOrLine = "columns"; //$NON-NLS-1$
+			if (!this.columnsComputing)
+				colOrLine ="rows"; //$NON-NLS-1$
+
+			if (this.symbol == null)	{
+				this.symbol = prefixR + (ahcCounter++);
+			}
+
+			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+			rw.eval("library(FactoMineR)"); //$NON-NLS-1$
+			rw.eval(this.symbol +" <- HCPC(" + this.target + //$NON-NLS-1$
+					", cluster.CA=\"" + colOrLine + "\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", nb.clust=" + this.numberOfClusters + //$NON-NLS-1$
+					", metric=\"" + this.metric + "\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", method=\"" + this.method + "\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", graph=FALSE)"); //$NON-NLS-1$
+			
+		} catch(Exception e) {
+			Log.printStackTrace(e);
+			return false;
+		}
+
+		// Reset the cached data
+		this.resetCache();
+		this.dirty = false;
+		return true;
+	}
 	
+	
+	
 	public void setParameters(Boolean columns, String metric, Integer nCluster, String method) {
-		if (columns != null) this.pColumns = columns;
-		if (metric != null) this.pMetric = metric;
-		if (nCluster != null) this.pNCluster = nCluster;
-		if (method != null) this.pMethod = method;
+		if (columns != null) this.columnsComputing = columns;
+		if (metric != null) this.metric = metric;
+		if (nCluster != null) this.numberOfClusters = nCluster;
+		if (method != null) this.method = method;
 		dirty = true;
 	}
 
 
 	@Override
 	public boolean loadParameters() {
-		this.setParameters(
-				this.getBooleanParameterValue(AHCPreferences.COLUMNS_COMPUTING),
-				this.getStringParameterValue(AHCPreferences.METRIC),
-				this.getIntParameterValue(AHCPreferences.N_CLUSTERS),
-				this.getStringParameterValue(AHCPreferences.METHOD)
-				);
+		// nothing to do
 		return true;
 	}
 
 	@Override
 	public boolean saveParameters() {
-		// TODO Auto-generated method stub
-		System.err.println("AHC.saveParameters(): not yet implemented.");
+		// nothing to do
 		return true;
 	}
 
@@ -156,10 +230,10 @@
 	
 	@Override
 	public boolean canCompute() {
-		return ca != null 
-				&& Arrays.binarySearch(AHC.getMethods(), pMethod) >= 0 
-				&& Arrays.binarySearch(AHC.getMetrics(), pMetric) >= 0
-				&& pNCluster >= 2;
+		return this.ca != null 
+				&& Arrays.binarySearch(AHC.getMethods(), this.method) >= 0 
+				&& Arrays.binarySearch(AHC.getMetrics(), this.metric) >= 0
+				&& this.numberOfClusters >= 2;
 	}
 
 	@Override
@@ -210,58 +284,6 @@
 		return metrics;
 	}
 
-	/** The prefix r. */
-	protected static String prefixR = "FactoMineRAHC"; //$NON-NLS-1$
-
-	/** The nocah. */
-	protected static int nocah = 1;
-
-	@Override
-	protected boolean _compute()	{
-
-		
-		Log.info("Computing CAH...");
-		try {
-			
-			// compute the lexical table
-			this.table.compute();
-			
-			
-			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
-
-			String colOrLine = "columns"; //$NON-NLS-1$
-			if (!pColumns)
-				colOrLine ="rows"; //$NON-NLS-1$
-
-			if (symbol == null)	{
-				symbol = prefixR+(nocah++);
-			}
-
-			rw.eval("library(FactoMineR)"); //$NON-NLS-1$
-
-
-			rw.eval(symbol +" <- HCPC("+target + //$NON-NLS-1$
-					", cluster.CA=\""+colOrLine+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
-					", nb.clust="+pNCluster + //$NON-NLS-1$
-					", metric=\""+pMetric+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
-					", method=\""+pMethod+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
-					", graph=FALSE)"); //$NON-NLS-1$
-		} catch(Exception e) {
-			System.out.println("Failed to compute CAH: "+e);
-			Log.printStackTrace(e);
-			return false;
-		}
-
-		// FIXME: persistence
-		this.saveParameter(AHCPreferences.N_CLUSTERS, this.pNCluster);
-		this.saveParameter(AHCPreferences.COLUMNS_COMPUTING, this.pColumns);
-
-		// Reset the cached data
-		this.resetCache();
-		dirty = false;
-		return true;
-	}
-
 	/**
 	 *
 	 * @param outfile
@@ -495,7 +517,7 @@
 	 * @param metric the metric to set
 	 */
 	public void setMetric(String metric) {
-		this.pMetric = metric;
+		this.metric = metric;
 	}
 
 	/**
@@ -503,31 +525,31 @@
 	 * @param method the method to set
 	 */
 	public void setMethod(String method) {
-		this.pMethod = method;
+		this.method = method;
 	}
 
 	/**
-	 * Sets the computing to columns or rows.
-	 * @param columns the columns to set
+	 * Sets the computing to columns or rows and rest the number of clusters to default value.
+	 * @param columnsComputing the columns to set
 	 */
-	public void setColumnsComputing(boolean columns) {
-		this.pColumns = columns;
+	public void setColumnsComputing(boolean columnsComputing) {
+		this.columnsComputing = columnsComputing;
 	}
 
 	/**
 	 * Sets the number of clusters to use for computing
-	 * @param nCluster the nCluster to set
+	 * @param nClusters the nCluster to set
 	 */
-	public void setNCluster(int nCluster) {
-		pNCluster = nCluster;
+	public void setNumberOfClusters(int nClusters) {
+		numberOfClusters = nClusters;
 	}
 
 	/**
 	 * Checks if the computing mode is set as columns. If not, the computing mode is set as rows.
-	 * @return the columns
+	 * @return  
 	 */
 	public boolean isColumnsComputing() {
-		return pColumns;
+		return columnsComputing;
 	}
 
 	/**
@@ -582,10 +604,10 @@
 
 	/**
 	 * Returns the number of clusters.
-	 * @return the nCluster
+	 * @return the number of clusters
 	 */
-	public int getNCluster() {
-		return pNCluster;
+	public int getNumberOfClusters() {
+		return numberOfClusters;
 	}
 
 	public CA getCA() {
@@ -606,10 +628,10 @@
 	@Override
 	public String getSimpleName() {
 		StringBuffer buffer = new StringBuffer();
-		if (pColumns != null) buffer.append(pColumns?"cols":"rows");
-		if (pMethod != null) buffer.append(" "+pMethod);
-		if (pMetric != null) buffer.append(" "+pMetric);
-		if (pNCluster != null) buffer.append(" "+pNCluster);
+		buffer.append(this.columnsComputing ? "cols" : "rows"); //$NON-NLS-1$
+		buffer.append(this.method);
+		buffer.append(this.metric);
+		buffer.append(this.numberOfClusters);
 		return this.getName();
 	}
 
@@ -618,6 +640,24 @@
 		return this.getName();
 	}
 
+	/**
+	 * Gets the 2D rendering state.
+	 * If false, the rendering will be done in 3D.
+	 * @return the rendering2D
+	 */
+	public boolean isRendering2D() {
+		return rendering2D;
+	}
 
+	/**
+	 * Sets the 2D rendering state.
+	 * If set to false, the rendering will be done in 3D.
+	 * @param rendering2d the rendering2D to set
+	 */
+	public void setRendering2D(boolean rendering2d) {
+		rendering2D = rendering2d;
+	}
 
+
+
 }
Index: tmp/org.txm.progression.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.progression.rcp/META-INF/MANIFEST.MF	(revision 652)
+++ tmp/org.txm.progression.rcp/META-INF/MANIFEST.MF	(revision 653)
@@ -23,9 +23,9 @@
  org.eclipse.swt,
  org.txm.core;bundle-version="0.7.0",
  org.txm.chartsengine.jfreechart.core;bundle-version="1.0.0",
- org.txm.rcp,
  org.eclipse.core.expressions;bundle-version="3.4.600",
- org.txm.searchengine.core;bundle-version="1.0.0"
+ org.txm.searchengine.core;bundle-version="1.0.0",
+ org.txm.rcp
 Export-Package: org.txm.progression.rcp.adapters,
  org.txm.progression.rcp.chartsengine.events,
  org.txm.progression.rcp.editors,
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 652)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/chartsengine/events/ProgressionEventCallBack.java	(revision 653)
@@ -31,14 +31,14 @@
 import org.txm.progression.core.functions.Progression;
 import org.txm.rcp.RCPMessages;
 import org.txm.rcp.editors.TXMResultEditorInput;
-import org.txm.rcp.synoptic.commands.OpenEdition;
-import org.txm.rcp.synoptic.editor.EditionPanel.RGBA;
-import org.txm.rcp.synoptic.editor.SynopticEditionEditor;
 import org.txm.rcp.utils.SWTEditorsUtils;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
 import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.synopticedition.rcp.editors.SynopticEditionEditor;
+import org.txm.synopticedition.rcp.editors.EditionPanel.RGBA;
+import org.txm.synopticedition.rcp.handlers.OpenEdition;
 import org.txm.utils.logger.Log;
 
 /**
Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/preferences/ProgressionPreferencePage.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/preferences/ProgressionPreferencePage.java	(revision 652)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/preferences/ProgressionPreferencePage.java	(revision 653)
@@ -31,15 +31,13 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.ui.IWorkbench;
 import org.txm.chartsengine.rcp.SWTChartsComponentsProvider;
-import org.txm.core.preferences.TXMPreferences;
 import org.txm.progression.core.messages.ProgressionCoreMessages;
 import org.txm.progression.core.preferences.ProgressionPreferences;
 import org.txm.progression.rcp.adapters.ProgressionAdapterFactory;
 import org.txm.progression.rcp.messages.ProgressionUIMessages;
+import org.txm.rcp.jface.DoubleFieldEditor;
 import org.txm.rcp.preferences.TXMPreferencePage;
 import org.txm.rcp.preferences.TXMPreferenceStore;
-import org.txm.rcp.TxmPreferences;
-import org.txm.rcp.jface.DoubleFieldEditor;
 
 /**
  * Progression preference page.
Index: tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 652)
+++ tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 653)
@@ -13,14 +13,14 @@
 Bundle-ClassPath: res/,
  .
 Bundle-Vendor: %Bundle-Vendor
-Export-Package: org.txm.functions.diagnostic,
- org.txm.functions.preview,
- org.txm.functions.selection,
- org.txm.functions.summary,
- org.txm.importer.cwb,
+Export-Package: org.txm.importer.cwb,
  org.txm.searchengine.cqp,
  org.txm.searchengine.cqp.clientExceptions,
+ org.txm.searchengine.cqp.core.functions.information,
+ org.txm.searchengine.cqp.core.functions.preview,
+ org.txm.searchengine.cqp.core.functions.selection,
+ org.txm.searchengine.cqp.core.functions.summary,
+ org.txm.searchengine.cqp.core.tests,
  org.txm.searchengine.cqp.corpus,
  org.txm.searchengine.cqp.corpus.query,
- org.txm.searchengine.cqp.serverException,
- org.txm.test
+ org.txm.searchengine.cqp.serverException
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 652)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 653)
@@ -39,11 +39,11 @@
 import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.results.TXMResult;
-import org.txm.functions.selection.SelectionResult;
 import org.txm.objects.Base;
 import org.txm.objects.TxmObject;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
+import org.txm.searchengine.cqp.core.functions.selection.SelectionResult;
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.corpus.query.QueryPart;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 652)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Subcorpus.java	(revision 653)
@@ -34,7 +34,6 @@
 import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.results.TXMParameters;
-import org.txm.functions.selection.SelectionResult;
 import org.txm.objects.Base;
 import org.txm.objects.TxmObject;
 import org.txm.searchengine.cqp.AbstractCqiClient;
@@ -42,6 +41,7 @@
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
+import org.txm.searchengine.cqp.core.functions.selection.SelectionResult;
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/tests/TestSubcorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/tests/TestSubcorpus.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/core/tests/TestSubcorpus.java	(revision 653)
@@ -0,0 +1,71 @@
+package org.txm.searchengine.cqp.core.tests;
+
+import java.io.File;
+import java.io.FileWriter;
+import java.io.IOException;
+import java.io.PrintWriter;
+import java.util.Arrays;
+
+import org.txm.searchengine.cqp.NetCqiClient;
+import org.txm.searchengine.cqp.clientExceptions.UnexpectedAnswerException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.CorpusManager;
+import org.txm.searchengine.cqp.corpus.Subcorpus;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
+
+public class TestSubcorpus {
+
+	public static String CORPUS = "DISCOURS"; //$NON-NLS-1$
+
+	public static boolean allTests(File outdir) {
+		TestSubcorpus tester = new TestSubcorpus();
+		return tester.test1(outdir) && tester.test2(outdir) && tester.test3(outdir);
+	}
+
+	public boolean test1(File outdir) {
+		try {
+			Corpus corpus = CorpusManager.getCorpusManager().getCorpus(CORPUS);
+			Subcorpus sub = corpus.createSubcorpus(new Query("\"je\" expand to p"), "JEP"); //$NON-NLS-1$ //$NON-NLS-2$
+
+			writePositions(sub, new File(outdir, TestSubcorpus.class.getName()+"_test1.csv")); //$NON-NLS-1$
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			return false;
+		}
+		return true;
+	}
+
+	public boolean test2(File outdir) {
+		try {
+			Corpus corpus = CorpusManager.getCorpusManager().getCorpus(CORPUS);
+			Subcorpus sub = corpus.createSubcorpus(corpus.getStructuralUnit("text"), corpus.getStructuralUnit("text").getProperty("loc"), "De_Gaulle", "DG"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+
+			writePositions(sub, new File(outdir, TestSubcorpus.class.getName()+"_test2.csv")); //$NON-NLS-1$
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			return false;
+		}
+		return true;
+	}
+
+	public boolean test3(File outdir) {
+		try {
+			Corpus corpus = CorpusManager.getCorpusManager().getCorpus(CORPUS);
+			Subcorpus sub = corpus.createSubcorpus(corpus.getStructuralUnit("text"), corpus.getStructuralUnit("text").getProperty("type"), Arrays.asList("Allocution radiotélévisée", "Conférence de presse"), "alloc+presse"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
+
+			writePositions(sub, new File(outdir, TestSubcorpus.class.getName()+"_test3.csv")); //$NON-NLS-1$
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			return false;
+		}
+		return true;
+	}
+
+	private void writePositions(Subcorpus sub, File outfile) throws UnexpectedAnswerException, IOException, CqiServerError {
+		int[] positions = CorpusManager.getCorpusManager().getCqiClient().dumpSubCorpus(sub.getQualifiedCqpId(), NetCqiClient.CQI_CONST_FIELD_MATCH, 0, sub.getNMatch());
+		PrintWriter writer = new PrintWriter(new FileWriter(outfile));
+		for(int i : positions) writer.println(i);
+		writer.close();
+	}
+}

